"""
This type stub file was generated by pyright.
"""

from typing import TYPE_CHECKING
from docutils import nodes
from docutils.writers.html5_polyglot import HTMLTranslator as BaseTranslator
from sphinx.util.docutils import SphinxTranslator
from docutils.nodes import Element, Text
from sphinx.builders import Builder
from sphinx.builders.html import StandaloneHTMLBuilder

"""Experimental docutils writers for HTML5 handling Sphinx's custom nodes."""
if TYPE_CHECKING:
    ...
logger = ...
def multiply_length(length: str, scale: int) -> str:
    """Multiply *length* (width or height) by *scale*."""
    ...

class HTML5Translator(SphinxTranslator, BaseTranslator):
    """
    Our custom HTML translator.
    """
    builder: StandaloneHTMLBuilder
    supported_inline_tags: set[str] = ...
    def __init__(self, document: nodes.document, builder: Builder) -> None:
        ...
    
    def visit_start_of_file(self, node: Element) -> None:
        ...
    
    def depart_start_of_file(self, node: Element) -> None:
        ...
    
    def visit_desc(self, node: Element) -> None:
        ...
    
    def depart_desc(self, node: Element) -> None:
        ...
    
    def visit_desc_signature(self, node: Element) -> None:
        ...
    
    def depart_desc_signature(self, node: Element) -> None:
        ...
    
    def visit_desc_signature_line(self, node: Element) -> None:
        ...
    
    def depart_desc_signature_line(self, node: Element) -> None:
        ...
    
    def visit_desc_content(self, node: Element) -> None:
        ...
    
    def depart_desc_content(self, node: Element) -> None:
        ...
    
    def visit_desc_inline(self, node: Element) -> None:
        ...
    
    def depart_desc_inline(self, node: Element) -> None:
        ...
    
    def visit_desc_name(self, node: Element) -> None:
        ...
    
    def depart_desc_name(self, node: Element) -> None:
        ...
    
    def visit_desc_addname(self, node: Element) -> None:
        ...
    
    def depart_desc_addname(self, node: Element) -> None:
        ...
    
    def visit_desc_type(self, node: Element) -> None:
        ...
    
    def depart_desc_type(self, node: Element) -> None:
        ...
    
    def visit_desc_returns(self, node: Element) -> None:
        ...
    
    def depart_desc_returns(self, node: Element) -> None:
        ...
    
    def visit_desc_parameterlist(self, node: Element) -> None:
        ...
    
    def depart_desc_parameterlist(self, node: Element) -> None:
        ...
    
    def visit_desc_type_parameter_list(self, node: Element) -> None:
        ...
    
    def depart_desc_type_parameter_list(self, node: Element) -> None:
        ...
    
    def visit_desc_parameter(self, node: Element) -> None:
        ...
    
    def depart_desc_parameter(self, node: Element) -> None:
        ...
    
    def visit_desc_type_parameter(self, node: Element) -> None:
        ...
    
    def depart_desc_type_parameter(self, node: Element) -> None:
        ...
    
    def visit_desc_optional(self, node: Element) -> None:
        ...
    
    def depart_desc_optional(self, node: Element) -> None:
        ...
    
    def visit_desc_annotation(self, node: Element) -> None:
        ...
    
    def depart_desc_annotation(self, node: Element) -> None:
        ...
    
    def visit_versionmodified(self, node: Element) -> None:
        ...
    
    def depart_versionmodified(self, node: Element) -> None:
        ...
    
    def visit_reference(self, node: Element) -> None:
        ...
    
    def visit_number_reference(self, node: Element) -> None:
        ...
    
    def depart_number_reference(self, node: Element) -> None:
        ...
    
    def visit_comment(self, node: Element) -> None:
        ...
    
    def visit_admonition(self, node: Element, name: str = ...) -> None:
        ...
    
    def depart_admonition(self, node: Element | None = ...) -> None:
        ...
    
    def visit_seealso(self, node: Element) -> None:
        ...
    
    def depart_seealso(self, node: Element) -> None:
        ...
    
    def get_secnumber(self, node: Element) -> tuple[int, ...] | None:
        ...
    
    def add_secnumber(self, node: Element) -> None:
        ...
    
    def add_fignumber(self, node: Element) -> None:
        ...
    
    def add_permalink_ref(self, node: Element, title: str) -> None:
        ...
    
    def visit_bullet_list(self, node: Element) -> None:
        ...
    
    def visit_definition(self, node: Element) -> None:
        ...
    
    def depart_definition(self, node: Element) -> None:
        ...
    
    def visit_classifier(self, node: Element) -> None:
        ...
    
    def depart_classifier(self, node: Element) -> None:
        ...
    
    def visit_term(self, node: Element) -> None:
        ...
    
    def depart_term(self, node: Element) -> None:
        ...
    
    def visit_title(self, node: Element) -> None:
        ...
    
    def depart_title(self, node: Element) -> None:
        ...
    
    def visit_literal_block(self, node: Element) -> None:
        ...
    
    def visit_caption(self, node: Element) -> None:
        ...
    
    def depart_caption(self, node: Element) -> None:
        ...
    
    def visit_doctest_block(self, node: Element) -> None:
        ...
    
    def visit_block_quote(self, node: Element) -> None:
        ...
    
    def depart_block_quote(self, node: Element) -> None:
        ...
    
    def visit_literal(self, node: Element) -> None:
        ...
    
    def depart_literal(self, node: Element) -> None:
        ...
    
    def visit_productionlist(self, node: Element) -> None:
        ...
    
    def depart_productionlist(self, node: Element) -> None:
        ...
    
    def visit_production(self, node: Element) -> None:
        ...
    
    def depart_production(self, node: Element) -> None:
        ...
    
    def visit_centered(self, node: Element) -> None:
        ...
    
    def depart_centered(self, node: Element) -> None:
        ...
    
    def visit_compact_paragraph(self, node: Element) -> None:
        ...
    
    def depart_compact_paragraph(self, node: Element) -> None:
        ...
    
    def visit_download_reference(self, node: Element) -> None:
        ...
    
    def depart_download_reference(self, node: Element) -> None:
        ...
    
    def visit_figure(self, node: Element) -> None:
        ...
    
    def visit_image(self, node: Element) -> None:
        ...
    
    def depart_image(self, node: Element) -> None:
        ...
    
    def visit_toctree(self, node: Element) -> None:
        ...
    
    def visit_index(self, node: Element) -> None:
        ...
    
    def visit_tabular_col_spec(self, node: Element) -> None:
        ...
    
    def visit_glossary(self, node: Element) -> None:
        ...
    
    def depart_glossary(self, node: Element) -> None:
        ...
    
    def visit_acks(self, node: Element) -> None:
        ...
    
    def depart_acks(self, node: Element) -> None:
        ...
    
    def visit_hlist(self, node: Element) -> None:
        ...
    
    def depart_hlist(self, node: Element) -> None:
        ...
    
    def visit_hlistcol(self, node: Element) -> None:
        ...
    
    def depart_hlistcol(self, node: Element) -> None:
        ...
    
    def visit_Text(self, node: Text) -> None:
        ...
    
    def visit_note(self, node: Element) -> None:
        ...
    
    def depart_note(self, node: Element) -> None:
        ...
    
    def visit_warning(self, node: Element) -> None:
        ...
    
    def depart_warning(self, node: Element) -> None:
        ...
    
    def visit_attention(self, node: Element) -> None:
        ...
    
    def depart_attention(self, node: Element) -> None:
        ...
    
    def visit_caution(self, node: Element) -> None:
        ...
    
    def depart_caution(self, node: Element) -> None:
        ...
    
    def visit_danger(self, node: Element) -> None:
        ...
    
    def depart_danger(self, node: Element) -> None:
        ...
    
    def visit_error(self, node: Element) -> None:
        ...
    
    def depart_error(self, node: Element) -> None:
        ...
    
    def visit_hint(self, node: Element) -> None:
        ...
    
    def depart_hint(self, node: Element) -> None:
        ...
    
    def visit_important(self, node: Element) -> None:
        ...
    
    def depart_important(self, node: Element) -> None:
        ...
    
    def visit_tip(self, node: Element) -> None:
        ...
    
    def depart_tip(self, node: Element) -> None:
        ...
    
    def visit_literal_emphasis(self, node: Element) -> None:
        ...
    
    def depart_literal_emphasis(self, node: Element) -> None:
        ...
    
    def visit_literal_strong(self, node: Element) -> None:
        ...
    
    def depart_literal_strong(self, node: Element) -> None:
        ...
    
    def visit_abbreviation(self, node: Element) -> None:
        ...
    
    def depart_abbreviation(self, node: Element) -> None:
        ...
    
    def visit_manpage(self, node: Element) -> None:
        ...
    
    def depart_manpage(self, node: Element) -> None:
        ...
    
    def visit_table(self, node: Element) -> None:
        ...
    
    def depart_table(self, node: Element) -> None:
        ...
    
    def visit_row(self, node: Element) -> None:
        ...
    
    def visit_field_list(self, node: Element) -> None:
        ...
    
    def depart_field_list(self, node: Element) -> None:
        ...
    
    def visit_field(self, node: Element) -> None:
        ...
    
    def visit_math(self, node: Element, math_env: str = ...) -> None:
        ...
    
    def depart_math(self, node: Element, math_env: str = ...) -> None:
        ...
    
    def visit_math_block(self, node: Element, math_env: str = ...) -> None:
        ...
    
    def depart_math_block(self, node: Element, math_env: str = ...) -> None:
        ...
    
    def visit_footnote_reference(self, node): # -> None:
        ...
    


